package ru.neroduckale.vapes;

import com.mojang.authlib.yggdrasil.response.User;
import net.minecraft.entity.Entity;
import net.minecraft.entity.LivingEntity;
import net.minecraft.entity.player.PlayerEntity;
import net.minecraft.entity.player.PlayerInventory;
import net.minecraft.item.Item;
import net.minecraft.item.ItemStack;
import net.minecraft.nbt.NbtCompound;
import net.minecraft.screen.NamedScreenHandlerFactory;
import net.minecraft.screen.ScreenHandler;
import net.minecraft.server.world.ServerWorld;
import net.minecraft.text.Text;
import net.minecraft.util.Hand;
import net.minecraft.util.TypedActionResult;
import net.minecraft.util.UseAction;
import net.minecraft.util.collection.DefaultedList;
import net.minecraft.util.math.Vec3d;
import net.minecraft.world.World;
import org.jetbrains.annotations.Nullable;
import ru.neroduckale.NeroduckaleVapes;
import ru.neroduckale.register.RegisterParticles;
import ru.neroduckale.util.ImplementedInventory;
import ru.neroduckale.fluids.ExampleFluid;
import ru.neroduckale.gui.prikolscreenhandler;
import ru.neroduckale.register.RegisterSounds;

public class Vape extends Item implements NamedScreenHandlerFactory, ImplementedInventory {
    public int mlbak;
    public int rasxod;

    private final DefaultedList<ItemStack> inventory = DefaultedList.ofSize(2, ItemStack.EMPTY);

    public Vape(Settings settings, int mlbak, int rasxod) {
        super(settings.maxCount(1));
        this.rasxod = rasxod;
        this.mlbak = mlbak;
    }

    //
    @Override
    public TypedActionResult<ItemStack> use(World world, PlayerEntity user, Hand hand) {
        if (!world.isClient()) {
            if (user.isInSneakingPose()) {
                user.openHandledScreen(this);
                return TypedActionResult.pass(user.getStackInHand(hand));
            }
            var stack = user.getStackInHand(hand);
            if (stack.getNbt().getInt("amountjija") <= 0) {
                user.sendMessage(Text.of("Жижи нет"), true);
                return TypedActionResult.fail(user.getStackInHand(hand));
            }
            NbtCompound nbt = new NbtCompound();
            nbt.putInt("amountjija", stack.getNbt().getInt("amountjija") - rasxod);
            stack.setNbt(nbt);
            user.setCurrentHand(hand);
        } else {
            var stack = user.getStackInHand(hand);
            if (stack.getNbt().getInt("amountjija") <= 0) {
                user.sendMessage(Text.of("Жижи нет"), true);
                return TypedActionResult.fail(user.getStackInHand(hand));
            }
            if (user.isInSneakingPose()) {
                return TypedActionResult.success(user.getStackInHand(hand));
            }
            user.setCurrentHand(hand);

        }
        user.playSound(RegisterSounds.VAPE, 2f, 1f);
        return TypedActionResult.pass(user.getStackInHand(hand));
    }

    public static void spawnParticles(World world, PlayerEntity user, Vec3d vec3d, int count) {
        var sw = (ServerWorld) world;
        sw.spawnParticles(RegisterParticles.MY_CLOUD, user.getX(), user.getEyeY(), user.getZ(), 0, vec3d.getX(), vec3d.getY(), vec3d.getZ(), 0.1f);
        sw.spawnParticles(RegisterParticles.RING_PARTICLE, user.getX(), user.getEyeY(), user.getZ(), 0, vec3d.getX(), vec3d.getY(), vec3d.getZ(), 0.1f);
        for (int i = 0; i < count; i++) {
            sw.spawnParticles(RegisterParticles.MY_CLOUD1, user.getX(), user.getEyeY(), user.getZ(), 0, vec3d.getX(), vec3d.getY(), vec3d.getZ(), 0.1f);
        }
    }


    @Override
    public Text getDisplayName() {
        return Text.literal("VAPE UI");
    }

    @Nullable
    @Override
    public ScreenHandler createMenu(int syncId, PlayerInventory playerInventory, PlayerEntity player) {
        return new prikolscreenhandler(syncId, playerInventory, this);
    }

    @Override
    public DefaultedList<ItemStack> getItems() {
        return inventory;
    }

    @Override
    public void inventoryTick(ItemStack stack, World world, Entity entity, int slot, boolean selected) {
        if (!world.isClient()) {
            if (!stack.hasNbt()) {
                NbtCompound nbtCompound = new NbtCompound();
                nbtCompound.putInt("amountjija", mlbak);
                stack.setNbt(nbtCompound);
            }
            if (inventory.get(0) != ItemStack.EMPTY && inventory.get(0).getItem() instanceof ExampleFluid && entity instanceof PlayerEntity user) {
                if (stack.getNbt().getInt("amountjija") != mlbak) { //Если бак в вейпе не полный
                    var fluiditemamount = getAmount(inventory.get(0));
                    var vapefluidamount = getAmount(stack);
                    var amountskokzalit = mlbak - vapefluidamount;
                    if (fluiditemamount >= amountskokzalit) {
                        inventory.get(0).getNbt().putInt("amountjija", fluiditemamount - amountskokzalit);
                        stack.getNbt().putInt("amountjija", vapefluidamount + amountskokzalit);
                        inventory.get(0).setDamage(inventory.get(0).getMaxDamage() - getAmount(inventory.get(0)));
                    } else if (fluiditemamount < amountskokzalit && fluiditemamount != 0) {
                        stack.getNbt().putInt("amountjija", vapefluidamount + fluiditemamount);
                        inventory.get(0).getNbt().putInt("amountjija", 0);
                        inventory.get(0).setDamage(inventory.get(0).getMaxDamage() - getAmount(inventory.get(0)));
                    }
                }
            }
        } else {
            if (entity instanceof PlayerEntity user && user.currentScreenHandler instanceof prikolscreenhandler p) {
                p.amountjija = getAmount(stack);
            }
        }
    }

    public int getAmount(ItemStack stack) {
        return stack.getNbt().getInt("amountjija");
    }

    @Override
    public void usageTick(World world, LivingEntity user, ItemStack stack, int remainingUseTicks) {
        
    }
    
    @Override
    public int getMaxUseTime(ItemStack stack) {
        return 72000;
    }

    @Override
    public void onStoppedUsing(ItemStack stack, World world, LivingEntity entity, int remainingUseTicks) {
        PlayerEntity user = (PlayerEntity) entity; 
        if (!world.isClient()) {
            user.getItemCooldownManager().set(this, 20);
            Vec3d vec3d = Vec3d.fromPolar(user.getPitch(), user.getYaw());
            vec3d.multiply(0.05f);
            float intp = getMaxUseTime(stack) - remainingUseTicks;
            float pizdec = intp / 20;
            spawnParticles(world, user, vec3d, Math.round(pizdec));
            NeroduckaleVapes.LOGGER.error(String.valueOf(pizdec));
        }
    }
}